From 32bdd062ed87ca43102aaf360c126874af14a036 Mon Sep 17 00:00:00 2001
From: Tomas Vondra <tomas.vondra@postgresql.org>
Date: Mon, 22 Mar 2021 05:10:37 +0100
Subject: [PATCH 5/5] move minmax-multi to contrib

---
 contrib/Makefile                              |   1 +
 contrib/brin_minmax_multi/.gitignore          |   4 +
 contrib/brin_minmax_multi/Makefile            |  23 +
 .../brin_minmax_multi--1.0.sql                | 552 ++++++++++++++++
 .../brin_minmax_multi}/brin_minmax_multi.c    |  63 +-
 .../brin_minmax_multi.control                 |   6 +
 .../expected/brin_multi.out                   |  21 +
 .../brin_minmax_multi}/sql/brin_multi.sql     |  25 +
 src/backend/access/brin/Makefile              |   1 -
 src/include/catalog/pg_amop.dat               | 545 ----------------
 src/include/catalog/pg_amproc.dat             | 597 ------------------
 src/include/catalog/pg_opclass.dat            |  57 --
 src/include/catalog/pg_opfamily.dat           |  28 -
 src/include/catalog/pg_proc.dat               |  85 +--
 src/include/catalog/pg_type.dat               |   6 -
 src/test/regress/expected/psql.out            |  11 +-
 src/test/regress/expected/type_sanity.out     |   7 +-
 src/test/regress/parallel_schedule            |   5 -
 src/test/regress/serial_schedule              |   1 -
 19 files changed, 703 insertions(+), 1335 deletions(-)
 create mode 100644 contrib/brin_minmax_multi/.gitignore
 create mode 100644 contrib/brin_minmax_multi/Makefile
 create mode 100644 contrib/brin_minmax_multi/brin_minmax_multi--1.0.sql
 rename {src/backend/access/brin => contrib/brin_minmax_multi}/brin_minmax_multi.c (96%)
 create mode 100644 contrib/brin_minmax_multi/brin_minmax_multi.control
 rename {src/test/regress => contrib/brin_minmax_multi}/expected/brin_multi.out (97%)
 rename {src/test/regress => contrib/brin_minmax_multi}/sql/brin_multi.sql (97%)

diff --git a/contrib/Makefile b/contrib/Makefile
index f878287429..bd131f8fc3 100644
--- a/contrib/Makefile
+++ b/contrib/Makefile
@@ -13,6 +13,7 @@ SUBDIRS = \
 		btree_gin	\
 		btree_gist	\
 		brin_bloom	\
+		brin_minmax_multi	\
 		citext		\
 		cube		\
 		dblink		\
diff --git a/contrib/brin_minmax_multi/.gitignore b/contrib/brin_minmax_multi/.gitignore
new file mode 100644
index 0000000000..5dcb3ff972
--- /dev/null
+++ b/contrib/brin_minmax_multi/.gitignore
@@ -0,0 +1,4 @@
+# Generated subdirectories
+/log/
+/results/
+/tmp_check/
diff --git a/contrib/brin_minmax_multi/Makefile b/contrib/brin_minmax_multi/Makefile
new file mode 100644
index 0000000000..9ca5112339
--- /dev/null
+++ b/contrib/brin_minmax_multi/Makefile
@@ -0,0 +1,23 @@
+# contrib/brin_minmax_multi/Makefile
+
+MODULE_big = brin_minmax_multi
+OBJS = \
+	$(WIN32RES) \
+	brin_minmax_multi.o
+
+EXTENSION = brin_minmax_multi
+DATA = brin_minmax_multi--1.0.sql
+PGFILEDESC = "brin_minmax_multi - BRIN minmax-multi operator classes"
+
+REGRESS = brin_multi
+
+ifdef USE_PGXS
+PG_CONFIG = pg_config
+PGXS := $(shell $(PG_CONFIG) --pgxs)
+include $(PGXS)
+else
+subdir = contrib/brin_minmax_multi
+top_builddir = ../..
+include $(top_builddir)/src/Makefile.global
+include $(top_srcdir)/contrib/contrib-global.mk
+endif
diff --git a/contrib/brin_minmax_multi/brin_minmax_multi--1.0.sql b/contrib/brin_minmax_multi/brin_minmax_multi--1.0.sql
new file mode 100644
index 0000000000..0e32d38bd9
--- /dev/null
+++ b/contrib/brin_minmax_multi/brin_minmax_multi--1.0.sql
@@ -0,0 +1,552 @@
+/* contrib/brin_minmax_multi/brin_minmax_multi--1.0.sql */
+
+-- complain if script is sourced in psql, rather than via CREATE EXTENSION
+\echo Use "CREATE EXTENSION brin_minmax_multi" to load this file. \quit
+
+CREATE TYPE brin_minmax_multi_summary;
+
+-- BRIN bloom summary data type
+CREATE FUNCTION brin_minmax_multi_summary_in(cstring)
+RETURNS brin_minmax_multi_summary
+AS 'MODULE_PATHNAME'
+LANGUAGE C STRICT IMMUTABLE PARALLEL SAFE;
+
+CREATE FUNCTION brin_minmax_multi_summary_out(brin_minmax_multi_summary)
+RETURNS cstring
+AS 'MODULE_PATHNAME'
+LANGUAGE C STRICT IMMUTABLE PARALLEL SAFE;
+
+CREATE FUNCTION brin_minmax_multi_summary_recv(internal)
+RETURNS brin_minmax_multi_summary
+AS 'MODULE_PATHNAME'
+LANGUAGE C STRICT IMMUTABLE PARALLEL SAFE;
+
+CREATE FUNCTION brin_minmax_multi_summary_send(brin_minmax_multi_summary)
+RETURNS bytea
+AS 'MODULE_PATHNAME'
+LANGUAGE C STRICT IMMUTABLE PARALLEL SAFE;
+
+CREATE TYPE brin_minmax_multi_summary (
+	INTERNALLENGTH = -1,
+	INPUT = brin_minmax_multi_summary_in,
+	OUTPUT = brin_minmax_multi_summary_out,
+	RECEIVE = brin_minmax_multi_summary_recv,
+	SEND = brin_minmax_multi_summary_send,
+	STORAGE = extended
+);
+
+-- BRIN support procedures
+CREATE FUNCTION brin_minmax_multi_opcinfo(internal)
+RETURNS internal
+AS 'MODULE_PATHNAME'
+LANGUAGE C STRICT IMMUTABLE;
+
+CREATE FUNCTION brin_minmax_multi_add_value(internal, internal, internal, internal)
+RETURNS bool
+AS 'MODULE_PATHNAME'
+LANGUAGE C STRICT IMMUTABLE;
+
+CREATE FUNCTION brin_minmax_multi_consistent(internal, internal, internal, int4)
+RETURNS bool
+AS 'MODULE_PATHNAME'
+LANGUAGE C STRICT IMMUTABLE;
+
+CREATE FUNCTION brin_minmax_multi_union(internal, internal, internal)
+RETURNS bool
+AS 'MODULE_PATHNAME'
+LANGUAGE C STRICT IMMUTABLE;
+
+CREATE FUNCTION brin_minmax_multi_options(internal)
+RETURNS void
+AS 'MODULE_PATHNAME'
+LANGUAGE C IMMUTABLE;
+
+-- distance functions
+
+CREATE FUNCTION brin_minmax_multi_distance_int2(int2, int2)
+RETURNS float8
+AS 'MODULE_PATHNAME'
+LANGUAGE C IMMUTABLE;
+
+CREATE FUNCTION brin_minmax_multi_distance_int4(int4, int4)
+RETURNS float8
+AS 'MODULE_PATHNAME'
+LANGUAGE C IMMUTABLE;
+
+CREATE FUNCTION brin_minmax_multi_distance_int8(int8, int8)
+RETURNS float8
+AS 'MODULE_PATHNAME'
+LANGUAGE C IMMUTABLE;
+
+CREATE FUNCTION brin_minmax_multi_distance_float4(float4, float4)
+RETURNS float8
+AS 'MODULE_PATHNAME'
+LANGUAGE C IMMUTABLE;
+
+CREATE FUNCTION brin_minmax_multi_distance_float8(float8, float8)
+RETURNS float8
+AS 'MODULE_PATHNAME'
+LANGUAGE C IMMUTABLE;
+
+CREATE FUNCTION brin_minmax_multi_distance_numeric(numeric, numeric)
+RETURNS float8
+AS 'MODULE_PATHNAME'
+LANGUAGE C IMMUTABLE;
+
+CREATE FUNCTION brin_minmax_multi_distance_tid(tid, tid)
+RETURNS float8
+AS 'MODULE_PATHNAME'
+LANGUAGE C IMMUTABLE;
+
+CREATE FUNCTION brin_minmax_multi_distance_uuid(uuid, uuid)
+RETURNS float8
+AS 'MODULE_PATHNAME'
+LANGUAGE C IMMUTABLE;
+
+CREATE FUNCTION brin_minmax_multi_distance_date(date, date)
+RETURNS float8
+AS 'MODULE_PATHNAME'
+LANGUAGE C IMMUTABLE;
+
+CREATE FUNCTION brin_minmax_multi_distance_time(time, time)
+RETURNS float8
+AS 'MODULE_PATHNAME'
+LANGUAGE C IMMUTABLE;
+
+CREATE FUNCTION brin_minmax_multi_distance_interval(interval, interval)
+RETURNS float8
+AS 'MODULE_PATHNAME'
+LANGUAGE C IMMUTABLE;
+
+CREATE FUNCTION brin_minmax_multi_distance_timetz(timetz, timetz)
+RETURNS float8
+AS 'MODULE_PATHNAME'
+LANGUAGE C IMMUTABLE;
+
+CREATE FUNCTION brin_minmax_multi_distance_pg_lsn(pg_lsn, pg_lsn)
+RETURNS float8
+AS 'MODULE_PATHNAME'
+LANGUAGE C IMMUTABLE;
+
+CREATE FUNCTION brin_minmax_multi_distance_macaddr(macaddr, macaddr)
+RETURNS float8
+AS 'MODULE_PATHNAME'
+LANGUAGE C IMMUTABLE;
+
+CREATE FUNCTION brin_minmax_multi_distance_macaddr8(macaddr8, macaddr8)
+RETURNS float8
+AS 'MODULE_PATHNAME'
+LANGUAGE C IMMUTABLE;
+
+CREATE FUNCTION brin_minmax_multi_distance_inet(inet, inet)
+RETURNS float8
+AS 'MODULE_PATHNAME'
+LANGUAGE C IMMUTABLE;
+
+CREATE FUNCTION brin_minmax_multi_distance_timestamp(timestamp, timestamp)
+RETURNS float8
+AS 'MODULE_PATHNAME'
+LANGUAGE C IMMUTABLE;
+
+CREATE OPERATOR FAMILY datetime_minmax_multi_ops USING brin;
+
+CREATE OPERATOR CLASS date_minmax_multi_ops
+FOR TYPE date USING brin FAMILY datetime_minmax_multi_ops
+AS
+    OPERATOR        1       <,
+    OPERATOR        2       <=,
+    OPERATOR        3       =,
+    OPERATOR        4       >=,
+    OPERATOR        5       >,
+    FUNCTION        1       brin_minmax_multi_opcinfo(internal),
+    FUNCTION        2       brin_minmax_multi_add_value(internal, internal, internal, internal),
+    FUNCTION        3       brin_minmax_multi_consistent(internal, internal, internal, int4),
+    FUNCTION        4       brin_minmax_multi_union(internal, internal, internal),
+    FUNCTION        5       brin_minmax_multi_options(internal),
+    FUNCTION       11       brin_minmax_multi_distance_date(date,date),
+STORAGE         date;
+
+CREATE OPERATOR FAMILY float_minmax_multi_ops USING brin;
+
+CREATE OPERATOR CLASS float4_minmax_multi_ops
+FOR TYPE float4 USING brin FAMILY float_minmax_multi_ops
+AS
+    OPERATOR        1       <,
+    OPERATOR        2       <=,
+    OPERATOR        3       =,
+    OPERATOR        4       >=,
+    OPERATOR        5       >,
+    FUNCTION        1       brin_minmax_multi_opcinfo(internal),
+    FUNCTION        2       brin_minmax_multi_add_value(internal, internal, internal, internal),
+    FUNCTION        3       brin_minmax_multi_consistent(internal, internal, internal, int4),
+    FUNCTION        4       brin_minmax_multi_union(internal, internal, internal),
+    FUNCTION        5       brin_minmax_multi_options(internal),
+    FUNCTION       11       brin_minmax_multi_distance_float4(float4,float4),
+STORAGE         float4;
+
+CREATE OPERATOR CLASS float8_minmax_multi_ops
+FOR TYPE float8 USING brin FAMILY float_minmax_multi_ops
+AS
+    OPERATOR        1       <,
+    OPERATOR        2       <=,
+    OPERATOR        3       =,
+    OPERATOR        4       >=,
+    OPERATOR        5       >,
+    FUNCTION        1       brin_minmax_multi_opcinfo(internal),
+    FUNCTION        2       brin_minmax_multi_add_value(internal, internal, internal, internal),
+    FUNCTION        3       brin_minmax_multi_consistent(internal, internal, internal, int4),
+    FUNCTION        4       brin_minmax_multi_union(internal, internal, internal),
+    FUNCTION        5       brin_minmax_multi_options(internal),
+    FUNCTION       11       brin_minmax_multi_distance_float8(float8,float8),
+STORAGE         float8;
+
+ALTER OPERATOR FAMILY float_minmax_multi_ops USING brin ADD
+
+    OPERATOR        1       <(float4,float8),
+    OPERATOR        2       <=(float4,float8),
+    OPERATOR        3       =(float4,float8),
+    OPERATOR        4       >=(float4,float8),
+    OPERATOR        5       >(float4,float8),
+
+    OPERATOR        1       <(float8,float4),
+    OPERATOR        2       <=(float8,float4),
+    OPERATOR        3       =(float8,float4),
+    OPERATOR        4       >=(float8,float4),
+    OPERATOR        5       >(float8,float4);
+
+CREATE OPERATOR FAMILY network_minmax_multi_ops USING brin;
+
+CREATE OPERATOR CLASS inet_minmax_multi_ops
+FOR TYPE inet USING brin FAMILY network_minmax_multi_ops
+AS
+    OPERATOR        1       <,
+    OPERATOR        2       <=,
+    OPERATOR        3       =,
+    OPERATOR        4       >=,
+    OPERATOR        5       >,
+    FUNCTION        1       brin_minmax_multi_opcinfo(internal),
+    FUNCTION        2       brin_minmax_multi_add_value(internal, internal, internal, internal),
+    FUNCTION        3       brin_minmax_multi_consistent(internal, internal, internal, int4),
+    FUNCTION        4       brin_minmax_multi_union(internal, internal, internal),
+    FUNCTION        5       brin_minmax_multi_options(internal),
+    FUNCTION       11       brin_minmax_multi_distance_inet(inet,inet),
+STORAGE         inet;
+
+CREATE OPERATOR FAMILY integer_minmax_multi_ops USING brin;
+
+CREATE OPERATOR CLASS int2_minmax_multi_ops
+FOR TYPE int2 USING brin FAMILY integer_minmax_multi_ops
+AS
+    OPERATOR        1       <,
+    OPERATOR        2       <=,
+    OPERATOR        3       =,
+    OPERATOR        4       >=,
+    OPERATOR        5       >,
+    FUNCTION        1       brin_minmax_multi_opcinfo(internal),
+    FUNCTION        2       brin_minmax_multi_add_value(internal, internal, internal, internal),
+    FUNCTION        3       brin_minmax_multi_consistent(internal, internal, internal, int4),
+    FUNCTION        4       brin_minmax_multi_union(internal, internal, internal),
+    FUNCTION        5       brin_minmax_multi_options(internal),
+    FUNCTION       11       brin_minmax_multi_distance_int2(int2,int2),
+STORAGE         int2;
+
+CREATE OPERATOR CLASS int4_minmax_multi_ops
+FOR TYPE int4 USING brin FAMILY integer_minmax_multi_ops
+AS
+    OPERATOR        1       <,
+    OPERATOR        2       <=,
+    OPERATOR        3       =,
+    OPERATOR        4       >=,
+    OPERATOR        5       >,
+    FUNCTION        1       brin_minmax_multi_opcinfo(internal),
+    FUNCTION        2       brin_minmax_multi_add_value(internal, internal, internal, internal),
+    FUNCTION        3       brin_minmax_multi_consistent(internal, internal, internal, int4),
+    FUNCTION        4       brin_minmax_multi_union(internal, internal, internal),
+    FUNCTION        5       brin_minmax_multi_options(internal),
+    FUNCTION       11       brin_minmax_multi_distance_int4(int4,int4),
+STORAGE         int4;
+
+CREATE OPERATOR CLASS int8_minmax_multi_ops
+FOR TYPE int8 USING brin FAMILY integer_minmax_multi_ops
+AS
+    OPERATOR        1       <,
+    OPERATOR        2       <=,
+    OPERATOR        3       =,
+    OPERATOR        4       >=,
+    OPERATOR        5       >,
+    FUNCTION        1       brin_minmax_multi_opcinfo(internal),
+    FUNCTION        2       brin_minmax_multi_add_value(internal, internal, internal, internal),
+    FUNCTION        3       brin_minmax_multi_consistent(internal, internal, internal, int4),
+    FUNCTION        4       brin_minmax_multi_union(internal, internal, internal),
+    FUNCTION        5       brin_minmax_multi_options(internal),
+    FUNCTION       11       brin_minmax_multi_distance_int8(int8,int8),
+STORAGE         int8;
+
+ALTER OPERATOR FAMILY integer_minmax_multi_ops USING brin ADD
+
+    OPERATOR        1       <(int2,int4),
+    OPERATOR        2       <=(int2,int4),
+    OPERATOR        3       =(int2,int4),
+    OPERATOR        4       >=(int2,int4),
+    OPERATOR        5       >(int2,int4),
+
+    OPERATOR        1       <(int2,int8),
+    OPERATOR        2       <=(int2,int8),
+    OPERATOR        3       =(int2,int8),
+    OPERATOR        4       >=(int2,int8),
+    OPERATOR        5       >(int2,int8),
+
+    OPERATOR        1       <(int4,int2),
+    OPERATOR        2       <=(int4,int2),
+    OPERATOR        3       =(int4,int2),
+    OPERATOR        4       >=(int4,int2),
+    OPERATOR        5       >(int4,int2),
+
+    OPERATOR        1       <(int4,int8),
+    OPERATOR        2       <=(int4,int8),
+    OPERATOR        3       =(int4,int8),
+    OPERATOR        4       >=(int4,int8),
+    OPERATOR        5       >(int4,int8),
+
+    OPERATOR        1       <(int8,int2),
+    OPERATOR        2       <=(int8,int2),
+    OPERATOR        3       =(int8,int2),
+    OPERATOR        4       >=(int8,int2),
+    OPERATOR        5       >(int8,int2),
+
+    OPERATOR        1       <(int8,int4),
+    OPERATOR        2       <=(int8,int4),
+    OPERATOR        3       =(int8,int4),
+    OPERATOR        4       >=(int8,int4),
+    OPERATOR        5       >(int8,int4);
+
+CREATE OPERATOR CLASS interval_minmax_multi_ops
+FOR TYPE interval USING brin
+AS
+    OPERATOR        1       <,
+    OPERATOR        2       <=,
+    OPERATOR        3       =,
+    OPERATOR        4       >=,
+    OPERATOR        5       >,
+    FUNCTION        1       brin_minmax_multi_opcinfo(internal),
+    FUNCTION        2       brin_minmax_multi_add_value(internal, internal, internal, internal),
+    FUNCTION        3       brin_minmax_multi_consistent(internal, internal, internal, int4),
+    FUNCTION        4       brin_minmax_multi_union(internal, internal, internal),
+    FUNCTION        5       brin_minmax_multi_options(internal),
+    FUNCTION       11       brin_minmax_multi_distance_interval(interval,interval),
+STORAGE         interval;
+
+CREATE OPERATOR CLASS macaddr_minmax_multi_ops
+FOR TYPE macaddr USING brin
+AS
+    OPERATOR        1       <,
+    OPERATOR        2       <=,
+    OPERATOR        3       =,
+    OPERATOR        4       >=,
+    OPERATOR        5       >,
+    FUNCTION        1       brin_minmax_multi_opcinfo(internal),
+    FUNCTION        2       brin_minmax_multi_add_value(internal, internal, internal, internal),
+    FUNCTION        3       brin_minmax_multi_consistent(internal, internal, internal, int4),
+    FUNCTION        4       brin_minmax_multi_union(internal, internal, internal),
+    FUNCTION        5       brin_minmax_multi_options(internal),
+    FUNCTION       11       brin_minmax_multi_distance_macaddr(macaddr,macaddr),
+STORAGE         macaddr;
+
+CREATE OPERATOR CLASS macaddr8_minmax_multi_ops
+FOR TYPE macaddr8 USING brin
+AS
+    OPERATOR        1       <,
+    OPERATOR        2       <=,
+    OPERATOR        3       =,
+    OPERATOR        4       >=,
+    OPERATOR        5       >,
+    FUNCTION        1       brin_minmax_multi_opcinfo(internal),
+    FUNCTION        2       brin_minmax_multi_add_value(internal, internal, internal, internal),
+    FUNCTION        3       brin_minmax_multi_consistent(internal, internal, internal, int4),
+    FUNCTION        4       brin_minmax_multi_union(internal, internal, internal),
+    FUNCTION        5       brin_minmax_multi_options(internal),
+    FUNCTION       11       brin_minmax_multi_distance_macaddr8(macaddr8,macaddr8),
+STORAGE         macaddr8;
+
+CREATE OPERATOR CLASS numeric_minmax_multi_ops
+FOR TYPE numeric USING brin
+AS
+    OPERATOR        1       <,
+    OPERATOR        2       <=,
+    OPERATOR        3       =,
+    OPERATOR        4       >=,
+    OPERATOR        5       >,
+    FUNCTION        1       brin_minmax_multi_opcinfo(internal),
+    FUNCTION        2       brin_minmax_multi_add_value(internal, internal, internal, internal),
+    FUNCTION        3       brin_minmax_multi_consistent(internal, internal, internal, int4),
+    FUNCTION        4       brin_minmax_multi_union(internal, internal, internal),
+    FUNCTION        5       brin_minmax_multi_options(internal),
+    FUNCTION       11       brin_minmax_multi_distance_numeric(numeric,numeric),
+STORAGE         numeric;
+
+CREATE OPERATOR CLASS oid_minmax_multi_ops
+FOR TYPE oid USING brin
+AS
+    OPERATOR        1       <,
+    OPERATOR        2       <=,
+    OPERATOR        3       =,
+    OPERATOR        4       >=,
+    OPERATOR        5       >,
+    FUNCTION        1       brin_minmax_multi_opcinfo(internal),
+    FUNCTION        2       brin_minmax_multi_add_value(internal, internal, internal, internal),
+    FUNCTION        3       brin_minmax_multi_consistent(internal, internal, internal, int4),
+    FUNCTION        4       brin_minmax_multi_union(internal, internal, internal),
+    FUNCTION        5       brin_minmax_multi_options(internal),
+    FUNCTION       11       brin_minmax_multi_distance_int4(int4,int4),
+STORAGE         oid;
+
+CREATE OPERATOR CLASS pg_lsn_minmax_multi_ops
+FOR TYPE pg_lsn USING brin
+AS
+    OPERATOR        1       <,
+    OPERATOR        2       <=,
+    OPERATOR        3       =,
+    OPERATOR        4       >=,
+    OPERATOR        5       >,
+    FUNCTION        1       brin_minmax_multi_opcinfo(internal),
+    FUNCTION        2       brin_minmax_multi_add_value(internal, internal, internal, internal),
+    FUNCTION        3       brin_minmax_multi_consistent(internal, internal, internal, int4),
+    FUNCTION        4       brin_minmax_multi_union(internal, internal, internal),
+    FUNCTION        5       brin_minmax_multi_options(internal),
+    FUNCTION       11       brin_minmax_multi_distance_pg_lsn(pg_lsn,pg_lsn),
+STORAGE         pg_lsn;
+
+CREATE OPERATOR CLASS tid_minmax_multi_ops
+FOR TYPE tid USING brin
+AS
+    OPERATOR        1       <,
+    OPERATOR        2       <=,
+    OPERATOR        3       =,
+    OPERATOR        4       >=,
+    OPERATOR        5       >,
+    FUNCTION        1       brin_minmax_multi_opcinfo(internal),
+    FUNCTION        2       brin_minmax_multi_add_value(internal, internal, internal, internal),
+    FUNCTION        3       brin_minmax_multi_consistent(internal, internal, internal, int4),
+    FUNCTION        4       brin_minmax_multi_union(internal, internal, internal),
+    FUNCTION        5       brin_minmax_multi_options(internal),
+    FUNCTION       11       brin_minmax_multi_distance_tid(tid,tid),
+STORAGE         tid;
+
+CREATE OPERATOR CLASS time_minmax_multi_ops
+FOR TYPE time USING brin
+AS
+    OPERATOR        1       <,
+    OPERATOR        2       <=,
+    OPERATOR        3       =,
+    OPERATOR        4       >=,
+    OPERATOR        5       >,
+    FUNCTION        1       brin_minmax_multi_opcinfo(internal),
+    FUNCTION        2       brin_minmax_multi_add_value(internal, internal, internal, internal),
+    FUNCTION        3       brin_minmax_multi_consistent(internal, internal, internal, int4),
+    FUNCTION        4       brin_minmax_multi_union(internal, internal, internal),
+    FUNCTION        5       brin_minmax_multi_options(internal),
+    FUNCTION       11       brin_minmax_multi_distance_time(time,time),
+STORAGE         time;
+
+CREATE OPERATOR CLASS timestamp_minmax_multi_ops
+FOR TYPE timestamp USING brin FAMILY datetime_minmax_multi_ops
+AS
+    OPERATOR        1       <,
+    OPERATOR        2       <=,
+    OPERATOR        3       =,
+    OPERATOR        4       >=,
+    OPERATOR        5       >,
+
+    FUNCTION        1       brin_minmax_multi_opcinfo(internal),
+    FUNCTION        2       brin_minmax_multi_add_value(internal, internal, internal, internal),
+    FUNCTION        3       brin_minmax_multi_consistent(internal, internal, internal, int4),
+    FUNCTION        4       brin_minmax_multi_union(internal, internal, internal),
+    FUNCTION        5       brin_minmax_multi_options(internal),
+    FUNCTION       11       brin_minmax_multi_distance_timestamp(timestamp,timestamp),
+STORAGE         timestamp;
+
+CREATE OPERATOR CLASS timestamptz_minmax_multi_ops
+FOR TYPE timestamptz USING brin FAMILY datetime_minmax_multi_ops
+AS
+    OPERATOR        1       <,
+    OPERATOR        2       <=,
+    OPERATOR        3       =,
+    OPERATOR        4       >=,
+    OPERATOR        5       >,
+    FUNCTION        1       brin_minmax_multi_opcinfo(internal),
+    FUNCTION        2       brin_minmax_multi_add_value(internal, internal, internal, internal),
+    FUNCTION        3       brin_minmax_multi_consistent(internal, internal, internal, int4),
+    FUNCTION        4       brin_minmax_multi_union(internal, internal, internal),
+    FUNCTION        5       brin_minmax_multi_options(internal),
+    FUNCTION       11       brin_minmax_multi_distance_timestamp(timestamp,timestamp),
+STORAGE         timestamptz;
+
+ALTER OPERATOR FAMILY datetime_minmax_multi_ops USING brin ADD
+
+    OPERATOR        1       <(timestamp,timestamptz),
+    OPERATOR        2       <=(timestamp,timestamptz),
+    OPERATOR        3       =(timestamp,timestamptz),
+    OPERATOR        4       >=(timestamp,timestamptz),
+    OPERATOR        5       >(timestamp,timestamptz),
+
+    OPERATOR        1       <(timestamp,date),
+    OPERATOR        2       <=(timestamp,date),
+    OPERATOR        3       =(timestamp,date),
+    OPERATOR        4       >=(timestamp,date),
+    OPERATOR        5       >(timestamp,date),
+
+    OPERATOR        1       <(date,timestamp),
+    OPERATOR        2       <=(date,timestamp),
+    OPERATOR        3       =(date,timestamp),
+    OPERATOR        4       >=(date,timestamp),
+    OPERATOR        5       >(date,timestamp),
+
+    OPERATOR        1       <(date,timestamptz),
+    OPERATOR        2       <=(date,timestamptz),
+    OPERATOR        3       =(date,timestamptz),
+    OPERATOR        4       >=(date,timestamptz),
+    OPERATOR        5       >(date,timestamptz),
+
+    OPERATOR        1       <(timestamptz,timestamp),
+    OPERATOR        2       <=(timestamptz,timestamp),
+    OPERATOR        3       =(timestamptz,timestamp),
+    OPERATOR        4       >=(timestamptz,timestamp),
+    OPERATOR        5       >(timestamptz,timestamp),
+
+    OPERATOR        1       <(timestamptz,date),
+    OPERATOR        2       <=(timestamptz,date),
+    OPERATOR        3       =(timestamptz,date),
+    OPERATOR        4       >=(timestamptz,date),
+    OPERATOR        5       >(timestamptz,date);
+
+CREATE OPERATOR CLASS timetz_minmax_multi_ops
+FOR TYPE timetz USING brin
+AS
+    OPERATOR        1       <,
+    OPERATOR        2       <=,
+    OPERATOR        3       =,
+    OPERATOR        4       >=,
+    OPERATOR        5       >,
+    FUNCTION        1       brin_minmax_multi_opcinfo(internal),
+    FUNCTION        2       brin_minmax_multi_add_value(internal, internal, internal, internal),
+    FUNCTION        3       brin_minmax_multi_consistent(internal, internal, internal, int4),
+    FUNCTION        4       brin_minmax_multi_union(internal, internal, internal),
+    FUNCTION        5       brin_minmax_multi_options(internal),
+    FUNCTION       11       brin_minmax_multi_distance_timetz(timetz,timetz),
+STORAGE         timetz;
+
+CREATE OPERATOR CLASS uuid_minmax_multi_ops
+FOR TYPE uuid USING brin
+AS
+    OPERATOR        1       <,
+    OPERATOR        2       <=,
+    OPERATOR        3       =,
+    OPERATOR        4       >=,
+    OPERATOR        5       >,
+    FUNCTION        1       brin_minmax_multi_opcinfo(internal),
+    FUNCTION        2       brin_minmax_multi_add_value(internal, internal, internal, internal),
+    FUNCTION        3       brin_minmax_multi_consistent(internal, internal, internal, int4),
+    FUNCTION        4       brin_minmax_multi_union(internal, internal, internal),
+    FUNCTION        5       brin_minmax_multi_options(internal),
+    FUNCTION       11       brin_minmax_multi_distance_uuid(uuid,uuid),
+STORAGE         uuid;
diff --git a/src/backend/access/brin/brin_minmax_multi.c b/contrib/brin_minmax_multi/brin_minmax_multi.c
similarity index 96%
rename from src/backend/access/brin/brin_minmax_multi.c
rename to contrib/brin_minmax_multi/brin_minmax_multi.c
index 1ca86b7fb7..bb6a9b9157 100644
--- a/src/backend/access/brin/brin_minmax_multi.c
+++ b/contrib/brin_minmax_multi/brin_minmax_multi.c
@@ -66,6 +66,7 @@
 #include "access/reloptions.h"
 #include "access/stratnum.h"
 #include "access/htup_details.h"
+#include "catalog/namespace.h"
 #include "catalog/pg_type.h"
 #include "catalog/pg_am.h"
 #include "catalog/pg_amop.h"
@@ -83,6 +84,8 @@
 #include "utils/timestamp.h"
 #include "utils/uuid.h"
 
+PG_MODULE_MAGIC;
+
 /*
  * Additional SQL level support functions
  *
@@ -257,6 +260,63 @@ static FmgrInfo *minmax_multi_get_strategy_procinfo(BrinDesc *bdesc,
 													uint16 attno, Oid subtype,
 													uint16 strategynum);
 
+Datum brin_minmax_multi_opcinfo(PG_FUNCTION_ARGS);
+Datum brin_minmax_multi_distance_float4(PG_FUNCTION_ARGS);
+Datum brin_minmax_multi_distance_float8(PG_FUNCTION_ARGS);
+Datum brin_minmax_multi_distance_int2(PG_FUNCTION_ARGS);
+Datum brin_minmax_multi_distance_int4(PG_FUNCTION_ARGS);
+Datum brin_minmax_multi_distance_int8(PG_FUNCTION_ARGS);
+Datum brin_minmax_multi_distance_tid(PG_FUNCTION_ARGS);
+Datum brin_minmax_multi_distance_numeric(PG_FUNCTION_ARGS);
+Datum brin_minmax_multi_distance_uuid(PG_FUNCTION_ARGS);
+Datum brin_minmax_multi_distance_date(PG_FUNCTION_ARGS);
+Datum brin_minmax_multi_distance_time(PG_FUNCTION_ARGS);
+Datum brin_minmax_multi_distance_timetz(PG_FUNCTION_ARGS);
+Datum brin_minmax_multi_distance_timestamp(PG_FUNCTION_ARGS);
+Datum brin_minmax_multi_distance_interval(PG_FUNCTION_ARGS);
+Datum brin_minmax_multi_distance_pg_lsn(PG_FUNCTION_ARGS);
+Datum brin_minmax_multi_distance_macaddr(PG_FUNCTION_ARGS);
+Datum brin_minmax_multi_distance_macaddr8(PG_FUNCTION_ARGS);
+Datum brin_minmax_multi_distance_inet(PG_FUNCTION_ARGS);
+Datum brin_minmax_multi_add_value(PG_FUNCTION_ARGS);
+Datum brin_minmax_multi_consistent(PG_FUNCTION_ARGS);
+Datum brin_minmax_multi_union(PG_FUNCTION_ARGS);
+Datum brin_minmax_multi_options(PG_FUNCTION_ARGS);
+Datum brin_minmax_multi_summary_in(PG_FUNCTION_ARGS);
+Datum brin_minmax_multi_summary_out(PG_FUNCTION_ARGS);
+Datum brin_minmax_multi_summary_recv(PG_FUNCTION_ARGS);
+Datum brin_minmax_multi_summary_send(PG_FUNCTION_ARGS);
+
+PG_FUNCTION_INFO_V1(brin_minmax_multi_summary_in);
+PG_FUNCTION_INFO_V1(brin_minmax_multi_summary_out);
+PG_FUNCTION_INFO_V1(brin_minmax_multi_summary_send);
+PG_FUNCTION_INFO_V1(brin_minmax_multi_summary_recv);
+
+PG_FUNCTION_INFO_V1(brin_minmax_multi_opcinfo);
+PG_FUNCTION_INFO_V1(brin_minmax_multi_options);
+PG_FUNCTION_INFO_V1(brin_minmax_multi_add_value);
+PG_FUNCTION_INFO_V1(brin_minmax_multi_consistent);
+PG_FUNCTION_INFO_V1(brin_minmax_multi_union);
+
+PG_FUNCTION_INFO_V1(brin_minmax_multi_distance_int2);
+PG_FUNCTION_INFO_V1(brin_minmax_multi_distance_int4);
+PG_FUNCTION_INFO_V1(brin_minmax_multi_distance_int8);
+PG_FUNCTION_INFO_V1(brin_minmax_multi_distance_float4);
+PG_FUNCTION_INFO_V1(brin_minmax_multi_distance_float8);
+PG_FUNCTION_INFO_V1(brin_minmax_multi_distance_numeric);
+PG_FUNCTION_INFO_V1(brin_minmax_multi_distance_tid);
+PG_FUNCTION_INFO_V1(brin_minmax_multi_distance_uuid);
+PG_FUNCTION_INFO_V1(brin_minmax_multi_distance_date);
+PG_FUNCTION_INFO_V1(brin_minmax_multi_distance_time);
+PG_FUNCTION_INFO_V1(brin_minmax_multi_distance_interval);
+PG_FUNCTION_INFO_V1(brin_minmax_multi_distance_timetz);
+PG_FUNCTION_INFO_V1(brin_minmax_multi_distance_pg_lsn);
+PG_FUNCTION_INFO_V1(brin_minmax_multi_distance_macaddr);
+PG_FUNCTION_INFO_V1(brin_minmax_multi_distance_macaddr8);
+PG_FUNCTION_INFO_V1(brin_minmax_multi_distance_inet);
+PG_FUNCTION_INFO_V1(brin_minmax_multi_distance_timestamp);
+
+
 typedef struct compare_context
 {
 	FmgrInfo   *cmpFn;
@@ -1782,6 +1842,7 @@ Datum
 brin_minmax_multi_opcinfo(PG_FUNCTION_ARGS)
 {
 	BrinOpcInfo *result;
+	Oid	typoid = TypenameGetTypidExtended("brin_minmax_multi_summary", false);
 
 	/*
 	 * opaque->strategy_procinfos is initialized lazily; here it is set to
@@ -1794,7 +1855,7 @@ brin_minmax_multi_opcinfo(PG_FUNCTION_ARGS)
 	result->oi_regular_nulls = true;
 	result->oi_opaque = (MinmaxMultiOpaque *)
 		MAXALIGN((char *) result + SizeofBrinOpcInfo(1));
-	result->oi_typcache[0] = lookup_type_cache(PG_BRIN_MINMAX_MULTI_SUMMARYOID, 0);
+	result->oi_typcache[0] = lookup_type_cache(typoid, 0);
 
 	PG_RETURN_POINTER(result);
 }
diff --git a/contrib/brin_minmax_multi/brin_minmax_multi.control b/contrib/brin_minmax_multi/brin_minmax_multi.control
new file mode 100644
index 0000000000..71e614867a
--- /dev/null
+++ b/contrib/brin_minmax_multi/brin_minmax_multi.control
@@ -0,0 +1,6 @@
+# brin_minmax_multi extension
+comment = 'support for BRIN minmax-multi indexes'
+default_version = '1.0'
+module_pathname = '$libdir/brin_minmax_multi'
+relocatable = true
+trusted = true
diff --git a/src/test/regress/sql/brin_multi.sql b/contrib/brin_minmax_multi/sql/brin_multi.sql
similarity index 97%
rename from src/test/regress/sql/brin_multi.sql
rename to contrib/brin_minmax_multi/sql/brin_multi.sql
index f5ffcaea33..c7b87c1ca3 100644
--- a/src/test/regress/sql/brin_multi.sql
+++ b/contrib/brin_minmax_multi/sql/brin_multi.sql
@@ -1,3 +1,28 @@
+CREATE EXTENSION brin_minmax_multi;
+
+CREATE TABLE tenk1 (
+	unique1		int4,
+	unique2		int4,
+	two			int4,
+	four		int4,
+	ten			int4,
+	twenty		int4,
+	hundred		int4,
+	thousand	int4,
+	twothousand	int4,
+	fivethous	int4,
+	tenthous	int4,
+	odd			int4,
+	even		int4,
+	stringu1	name,
+	stringu2	name,
+	string4		name
+);
+
+\copy tenk1 from '../../src/test/regress/data/tenk.data'
+
+CREATE INDEX tenk1_unique1 ON tenk1 USING btree(unique1 int4_ops);
+
 CREATE TABLE brintest_multi (
 	int8col bigint,
 	int2col smallint,
